
#include"stc12C5A.h"



//=============================================================
//Һӿ
sbit CS=P1^0;		//Ƭѡ
sbit RS=P1^1;		///ѡ
sbit _WR=P1^2;
sbit _RD=P1^3;		     //
sbit RES=P2^6;		//λ

sbit KEY = P2^7;

 #define HDATABUS	P3                  //߰λݿʹP3
 #define LDATABUS	P0                  //ͰλݿʹP0
//====================================================//
//
void SSD2119_Initial(void);
void Write_Cmd_Data(unsigned char a, unsigned int b);
void Write_Cmd(unsigned char DH,unsigned char DL);
void Write_Data(unsigned char DH,unsigned char DL);
void delayms(unsigned int tt);
void  Write_Data_U16(unsigned int dat);
static void LCD_SetPos(unsigned int x0,unsigned int y0);
void ClearScreen(unsigned int bColor);

//===============================================================
//
void ClearScreen(unsigned int bColor)
{
 unsigned int i,j;
 LCD_SetPos(0,0);//320x240
 for (i=0;i<320;i++)
	{
	
	   for (j=0;j<240;j++)
	       Write_Data_U16(bColor);
	}
}


//===============================================================
//д

void  Write_Cmd_Data (unsigned char a,unsigned int b)
{
	unsigned char m,n;
	m=b>>8;
	n=b;
	Write_Cmd(0x00,a);
	Write_Data(m,n);

}

//==============================================================
//д16λ
void  Write_Data_U16(unsigned int dat)
{
	unsigned char m,n;
	m=dat>>8;
	n=dat;
	Write_Data(m,n);

}
//=============================================================
//д

void Write_Cmd(unsigned char DH,unsigned char DL)
{
  
	CS=0;
	RS=0;

	HDATABUS=DH;
	LDATABUS=DL;
	
	_WR=0;
	_WR=1;
	CS=1;
}

//===================================================================
//д

void Write_Data(unsigned char DH,unsigned char DL)
{
 
  
	
	CS=0;
		
	RS=1;
	HDATABUS=DH;
	LDATABUS=DL;	
	_WR=0;
	_WR=1;
	CS=1;
}




//============================================================
//ʱ
void delay_us(unsigned int i)
{

    while(i--)
	{_nop_();
	}

}



void delayms(unsigned int count)
{
    int i,j;                                                                                
    for(i=0;i<count;i++)                                                                    
       {
	     for(j=0;j<1000;j++);
       }                                                                                     
}


//============================================================
//ʾҽ

void DispRGBGray(void)
{  


	unsigned int COL=320;
	unsigned char i,j,k,dbl,dbh;
	
	LCD_SetPos(0,0);

	// balck -> red	
	for(k=0;k<40;k++)
	{
		for(i=0;i<32;i++)
		{
			for(j=0;j<10;j++)
			{
				dbh=i<<3;
				dbl=0;
			Write_Data(dbh,dbl);
			}
		}
	}

	// red -> black
	for(k=0;k<40;k++)
	{	

		for(i=31;i>0;i--)
		{
			for(j=0;j<10;j++)
			{
				dbh=i<<3;
				dbl=0;
			Write_Data(dbh,dbl);
			}
		}
		
		dbh=0x00;dbl=0x00;
		for(i=0;i<10;i++)
		Write_Data(dbh,dbl);
		

	}
	// balck -> green
	for(k=0;k<40;k++)
	{

		for(i=0;i<64;i+=2)
		{
			for(j=0;j<10;j++)
			{
				dbh=i>>3;
				dbl=i<<5;
			Write_Data(dbh,dbl);
			}
		}
	}

	// green -> black
	for(k=0;k<40;k++)
	{
		for(i=63;i!=1;i-=2)
		{
			for(j=0;j<10;j++)
			{
				dbh=i>>3;
				dbl=i<<5;
			Write_Data(dbh,dbl);
			}
		}
		dbh=0x00;dbl=0x00;
		for(i=0;i<10;i++)
		Write_Data(dbh,dbl);
	}	


	// balck -> blue
	for(k=0;k<40;k++)
	{
		for(i=0;i<32;i++)
		{
			for(j=0;j<10;j++)
			{
				dbh=0;
				dbl=i;
			Write_Data(dbh,dbl);
			}
		}
	}

	// blue -> black
	for(k=0;k<40;k++)
	{	

		for(i=31;i>0;i--)
		{
			for(j=0;j<10;j++)
			{
				dbh=0;
				dbl=i;
			Write_Data(dbh,dbl);
			}
		}
		dbh=0x00;dbl=0x00;
		for(i=0;i<10;i++)
		Write_Data(dbh,dbl);
	}


}




//============================================================
//ȫ

void LCD_FULL(unsigned int i)
{
    unsigned int w,u;
 LCD_SetPos(0,0);

	    for(w=0;w<320;w++)
		{    
          	Write_Data_U16(~i);

		}

  	for(w=0;w<238;w++)		    
        {  	Write_Data_U16(~i);
	    	
			for(u=0;u<318;u++)
         	Write_Data_U16(i);

          	Write_Data_U16(~i);		
		}

	    for(w=0;w<320;w++)
		{    
          	Write_Data_U16(~i);

		}	
	
}





//=============================================================
//Һʼ

void SSD2119_Initial(void)
{ 
	 delayms(5);
	 RES=0;
	 delayms(5);
	 RES=1;
 	 delayms(20);   //ݲͬٶȿԵʱȶʾ


	

 		 Write_Cmd_Data(0x0028,0x0006);    // VCOM OTP
 

		 Write_Cmd_Data(0x0000,0x0001);    // start Oscillator

	
		 Write_Cmd_Data(0x0010,0x0000);    // Sleep mode

	
		 Write_Cmd_Data(0x0001,0x72EF);    //72EF Driver Output Control    


	
		 Write_Cmd_Data(0x0002,0x0600);    // LCD Driving Waveform Control

	
		 Write_Cmd_Data(0x0003,0x6A38);    // Power Control 1

	
	    Write_Cmd_Data(0x0011,0x6270);    //6270 Entry Mode   Horizontal screen mode   320*240    65k colour
	   // Write_Cmd_Data(0x0011,0x6218);  	//   Vertical screen mode     240*320   65k colour

	
		 Write_Cmd_Data(0X000F,0x0000);    // Gate Scan Position

	
		 Write_Cmd_Data(0X000B,0x5308);    // Frame Cycle Control

	
		 Write_Cmd_Data(0x000C,0x0003);    // Power Control 2

	
		 Write_Cmd_Data(0x000D,0x000A);    // Power Control 3

		 Write_Cmd_Data(0x000E,0x3200);    // VCOM Control 4

	
		 Write_Cmd_Data(0x001E,0x00be);    // Power Control 5

	
		 Write_Cmd_Data(0x0025,0x8000);    // Frame Frequency Control

	
		 Write_Cmd_Data(0x0026,0x7800);    // Analog setting

 		 Write_Cmd_Data(0x0027,0x0078);    // 			   ************
	
		 Write_Cmd_Data(0x004E,0x0000);    // Ram Address Set

	
		 Write_Cmd_Data(0x004F,0x0000);    // Ram Address Set

	
		 Write_Cmd_Data(0x0012,0x08D9);    // Sleep mode

	
		
		// Gamma Control (R30h to R3Bh) -- Page 56 of SSD2119 datasheet
		 Write_Cmd_Data(0x0030,0x0000);
	
		 Write_Cmd_Data(0x0031,0x0104);
	
		 Write_Cmd_Data(0x0032,0x0100);
	
		 Write_Cmd_Data(0x0033,0x0305);
	
		 Write_Cmd_Data(0x0034,0x0505);
	
		 Write_Cmd_Data(0x0035,0x0305);
	
		 Write_Cmd_Data(0x0036,0x0707);
	
		 Write_Cmd_Data(0x0037,0x0300);
	
		 Write_Cmd_Data(0x003A,0x1200);
	
		 Write_Cmd_Data(0x003B,0x0800);		  
		 	





		 Write_Cmd_Data(0x0007,0x0033);    // Display Control 

	
		 delayms(20);
	


}



//===============================================================
//
static void LCD_SetPos(unsigned int x0,unsigned int y0)
{

  	Write_Cmd_Data(0x0044,0xEF00);    // Vertical RAM start/end address position
       // Page 57 of SSD2119 datasheet
  	Write_Cmd_Data(0x0045,0x0000);    // Horizontal RAM start address position  
       // Page 57 of SSD2119 datasheet
  	Write_Cmd_Data(0x0046,0x013F);    // Horizontal RAM end address position
       // Page 57 of SSD2119 datasheet


  	Write_Cmd_Data(0x004E,x0);    // RAM address set
       // Page 58 of SSD2119 datasheet
  	Write_Cmd_Data(0x004F,y0);    // RAM address set
       // Page 58 of SSD2119 datasheet

  Write_Cmd (0x00,0x22);//LCD_WriteCMD(GRAMWR);
}




